package com.mortals.xhx.module.window.service.impl;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.window.dao.WindowWorkmanPerformDetailDao;
import com.mortals.xhx.module.window.model.WindowWorkmanPerformDetailEntity;
import com.mortals.xhx.module.window.service.WindowWorkmanPerformDetailService;
import lombok.extern.slf4j.Slf4j;
/**
* WindowWorkmanPerformDetailService
* 窗口人员考核汇总明细 service实现
*
* @author zxfei
* @date 2024-01-17
*/
@Service("windowWorkmanPerformDetailService")
@Slf4j
public class WindowWorkmanPerformDetailServiceImpl extends AbstractCRUDServiceImpl<WindowWorkmanPerformDetailDao, WindowWorkmanPerformDetailEntity, Long> implements WindowWorkmanPerformDetailService {

    @Override
    public Result<WindowWorkmanPerformDetailEntity> find(WindowWorkmanPerformDetailEntity entity, PageInfo pageInfo, Context context) throws AppException {
        WindowWorkmanPerformDetailEntity newParams = this.findBefore(entity, pageInfo, context);
        Result<WindowWorkmanPerformDetailEntity> result = this.dao.getListExt(newParams, pageInfo);
        this.findAfter(entity, pageInfo, context, result.getList());
        return result;
    }
}